/*
** Module   :KBRAW.CPP
** Abstract :
**
** Copyright (C) Sergey I. Yevtushenko
**
** Log: Tue  12/03/2002 Created
**
*/

#define INCL_BASE
#define INCL_WIN
#define INCL_VIO
#define INCL_KBD
#include <os2.h>

#include <stdio.h>

#define TRC(x)     fprintf(stdout, "%s %d " #x " = %d (%x)\n", __FILE__, __LINE__, x, x)


void vio_init(void)
{
    HKBD hKbd = 0;
    KBDINFO kbInfo;
    kbInfo.cb = sizeof(KBDINFO);
    int rc;

    rc = KbdFlushBuffer(hKbd);
    rc = KbdGetStatus(&kbInfo, hKbd);

    kbInfo.fsMask = KEYBOARD_BINARY_MODE | KEYBOARD_SHIFT_REPORT ;
    rc = KbdSetStatus(&kbInfo, hKbd);
    rc = KbdFlushBuffer(hKbd);
}

USHORT vio_read_key(void)
{
    KBDKEYINFO skInfo;
    HKBD   hKbd    = 0;
    APIRET rc      = 0;
    USHORT usKey   = 0;
    USHORT usShift = 0;

    rc = KbdCharIn(&skInfo, IO_WAIT, hKbd);

TRC(skInfo.chScan);
TRC(skInfo.chChar);
TRC(skInfo.fsState);

    return (skInfo.chScan << 8) | skInfo.chChar;
}

main()
{
    USHORT key;

    vio_init();

    do
    {
	    key = vio_read_key();
TRC(key);
    }
    while(key != 0x11B);
}

